---
title: PublicKeyCredentialRequestOptions.allowCredentials
slug: Web/API/PublicKeyCredentialRequestOptions/allowCredentials
tags:
  - API
  - Property
  - PublicKeyCredentialRequestOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p><strong><code>allowCredentials</code></strong> is an optional property of the {{domxref("PublicKeyCredentialRequestOptions")}} dictionary which indicates the existing credentials acceptable for retrieval. This is an {{jsxref("Array")}} of credential descriptors.</p>

<div class="notecard note">
<p><strong>Note:</strong> {{domxref("PublicKeyCredentialCreationOptions.excludeCredentials")}} may be used during the creation of the credentials in order to avoid creating new credentials for an existing user with existing public key credential. Contrary to <code>allowCredentials</code>, it is used to <em>filter out</em> credentials.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>allowCredentials </em>= <em>publicKeyCredentialRequestOptions</em>.allowCredentials</pre>

<h3 id="Value">Value</h3>

<p>An {{jsxref("Array")}} whose elements are objects with the following properties:</p>

<dl>
	<dt><code>type</code></dt>
	<dd>A string describing type of public-key credential to be created. As of this writing (March 2019), only <code>"public-key"</code> may be used.</dd>
	<dt><code>id</code></dt>
	<dd>A {{domxref("BufferSource")}} matching an existing public key credential identifier ({{domxref("PublicKeyCredential.rawId")}}). This identifier is generated during the creation of the <code>PublicKeyCredential</code> instance.</dd>
	<dt><code>transports</code> {{optional_inline}}</dt>
	<dd>An {{jsxref("Array")}} of strings describing the possible transports between the client and the authenticator. The value of the strings may be:
	<ul>
		<li><code>"usb"</code>: the authenticator can be contacted via a removable USB link</li>
		<li><code>"nfc"</code>: the authenticator may be used over <a href="https://en.wikipedia.org/wiki/Near-field_communication">NFC (Near Field Communication)</a></li>
		<li><code>"ble"</code>: the authenticator may be used over <a href="https://en.wikipedia.org/wiki/Bluetooth_Low_Energy">BLE (Bluetooth Low Energy)</a></li>
		<li><code>"internal"</code>: the authenticator is specifically bound to the client device (cannot be removed).</li>
	</ul>
	</dd>
</dl>

<p>If the authenticator does not contain any of these public key credentials, the client will throw a {{domxref("DOMException")}} <code>"NotAllowedError"</code>.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var options = {
  allowCredentials: [
    {
      transports: ["usb"],
      type: "public-key",
      id: new Uint8Array(26) // actually provided by the server
    },
    {
      transports: ["internal"],
      type: "public-key",
      id: new Uint8Array(26) // actually provided by the server
    }
  ],
  challenge: new Uint8Array([/* bytes sent from the server */])
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('WebAuthn','#dom-publickeycredentialrequestoptions-allowcredentials','allowCredentials')}}</td>
			<td>{{Spec2('WebAuthn')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialRequestOptions.allowCredentials")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("PublicKeyCredentialCreationOptions.excludeCredentials")}} which is used to filter out existing credentials during creation and avoid creating new credentials for an existing user</li>
</ul>
